import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cR as LogMessage, a as LogHandler } from './uuid-c4ad7468.js';
export { dr as ArgumentsType, ck as AsyncMutex, V as BinInput, c$ as Channel, c_ as ChannelMessageEvent, dd as CryptoEncoder, au as Currency, as as CurrencyInput, av as DAY_MS, aS as Day, ax as DayInput, aR as DayInputLegacy, aw as DayValue, aY as DecimalInput, aX as DecimalValue, d5 as DefaultListener, ca as Disposable, c9 as Disposer, c8 as DisposerFunction, d6 as Emitter, d3 as EmitterAllHandler, d2 as EmitterHandler, da as Encoder, J as Json, dc as JsonEncoder, d4 as ListenerSignature, d0 as LocalChannel, a as LogHandler, L as LogHandlerOptions, c as LogLevel, cO as LogLevelAlias, cP as LogLevelAliasKey, cQ as LogLevelAliasType, cR as LogMessage, cN as Logger, cU as LoggerConsoleHandler, cT as LoggerContext, cS as LoggerContextInterface, b as LoggerInterface, cZ as LoggerMemoryHandler, dN as MemStorage, dM as MemStorageOptions, dg as Message, de as MessageAction, dk as MessageDefinitions, dl as MessageHub, df as MessageResult, di as MessagesDefaultMethods, dj as MessagesMethods, dh as MessagesOptions, cj as Mutex, dR as NestedArray, db as NoopEncoder, O as ObjectStorage, ct as Pool, cp as PoolTask, cr as PoolTaskEvents, cn as PoolTaskFn, cq as PoolTaskIdConflictResolution, co as PoolTaskState, b6 as Primitive, dp as PubSub, du as RPCFn, dt as RPCOptions, dv as RPCReturn, ao as RenderMessagesOptions, ds as ReturnType, bD as RoundingMode, cH as SerialQueue, bO as SortableItem, cG as TaskEvents, cF as TaskFn, a8 as Uint8ArrayToHexDump, a7 as Uint8ArrayToJson, Y as Uint8ArrayToString, cf as UseDefer, cc as UseDispose, c7 as XRX, W as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, E as arrayAvg, F as arrayBatches, t as arrayEmptyInPlace, q as arrayFilterInPlace, l as arrayFlatten, m as arrayIntersection, w as arrayIsEqual, B as arrayMax, C as arrayMin, j as arrayMinus, A as arrayRandomElement, o as arrayRemoveElement, p as arraySetElement, y as arrayShuffle, z as arrayShuffleForce, x as arrayShuffleInPlace, u as arraySorted, v as arraySortedNumbers, D as arraySum, n as arraySymmetricDifference, s as arrayToggleInPlace, k as arrayUnion, i as arrayUnique, bs as avg, bq as between, c1 as cloneJsonObject, c0 as cloneObject, bz as cmp, by as composeOrderby, G as createArray, d1 as createLocalChannelPair, cu as createPromise, dm as createPromiseProxy, h as csv, at as currency, aW as dateStringToDays, aV as day, aA as dayDay, aQ as dayDiff, aE as dayFromAny, aG as dayFromDate, aH as dayFromDateGMT, aL as dayFromParts, aM as dayFromString, aJ as dayFromTimestamp, aD as dayFromToday, az as dayMonth, aN as dayMonthStart, aP as dayOffset, aC as dayToDate, aF as dayToDateGMT, aB as dayToParts, aK as dayToString, aI as dayToTimestamp, ay as dayYear, aO as dayYearStart, cJ as debounce, aZ as decimal, b0 as decimalCentsPart, a_ as decimalFromCents, a$ as decimalToCents, K as decodeBase16, N as decodeBase32, Q as decodeBase58, S as decodeBase62, U as decodeBase64, g as decrypt, b1 as deepEqual, b3 as deepMerge, b2 as deepStripUndefinedInPlace, e as deriveKeyPbkdf2, dI as detect, d as digest, b$ as empty, I as encodeBase16, M as encodeBase32, P as encodeBase58, R as encodeBase62, T as encodeBase64, bV as encodeQuery, f as encrypt, bQ as endSortWeight, bX as ensureKey, bY as ensureKeyAsync, a5 as equalBinary, b4 as escapeHTML, bC as escapeRegExp, dz as fetchBasic, dA as fetchJson, dE as fetchOptionsBasicAuth, dC as fetchOptionsFormURLEncoded, dD as fetchOptionsJson, dB as fetchText, ar as fixBrokenUth8String, aT as forEachDay, c4 as forTimes, ap as formatMessages, dP as formatMilliseconds, a4 as fromBase64, ac as fromCamelCase, a1 as fromHex, dH as getGlobal, cK as getGlobalContext, d7 as getGlobalEmitter, cM as getGlobalLogger, cV as getNamespaceFilterString, dG as getNavigator, bl as getSecureRandom, bm as getSecureRandomIfPossible, dO as getTimestamp, dF as getWindow, dx as httpMethod, cw as immediate, b9 as isArray, bf as isBoolean, dJ as isBrowser, bF as isEven, bE as isHalf, bd as isInteger, cL as isLocalHost, bg as isNullOrUndefined, bc as isNumber, b7 as isObject, bu as isPrime, bt as isPrimeRX, b8 as isPrimitive, cD as isPromise, ba as isRecord, be as isSafeInteger, bb as isString, cA as isTimeout, bh as isUint8Array, $ as joinToUint8Array, bk as jsonStringify, bj as jsonStringifySafe, bi as jsonStringifySorted, a6 as jsonToUint8Array, b_ as last, d9 as lazyListener, bT as linkifyPlainText, c2 as memoize, c3 as memoizeAsync, d8 as messages, bR as moveSortWeight, bw as objectMap, dy as parseBasicAuth, dQ as parseDate, cX as parseLogLevel, bx as parseOrderby, bW as parseQuery, dK as platform, cE as promisify, e1 as qid, bn as randomBoolean, bp as randomFloat, bo as randomInt, r as randomUint8Array, c6 as regExpEscape, c5 as regExpString, aq as renderMessages, bH as roundDown, bK as roundHalfAwayFromZero, bL as roundHalfDown, bM as roundHalfEven, bJ as roundHalfOdd, bN as roundHalfTowardsZero, bI as roundHalfUp, bG as roundUp, bv as seededRandom, bZ as size, cv as sleep, bS as sortedItems, bA as sortedOrderby, bP as startSortWeight, ad as stringToBoolean, af as stringToFloat, ae as stringToInteger, X as stringToUInt8Array, e4 as suid, e3 as suidBytes, e6 as suidBytesDate, e5 as suidDate, br as sum, cI as throttle, cy as timeout, cx as timeoutReached, cz as timoutError, a2 as toBase64, a3 as toBase64Url, an as toBool, a9 as toCamelCase, aa as toCapitalize, ab as toCapitalizeWords, ak as toFloat, a0 as toHex, bU as toHumanReadableUrl, al as toInt, am as toString, Z as toUint8Array, bB as toValidFilename, aU as today, cB as tryTimeout, e0 as uname, b5 as unescapeHTML, cm as useAsyncMutex, H as useBase, ce as useDefer, cb as useDispose, cd as useDisposer, ci as useEventListener, dL as useExitHandler, ch as useInterval, cY as useLevelFilter, dn as useMessageHub, cl as useMutex, cW as useNamespaceFilter, cs as usePool, dq as usePubSub, dw as useRPC, cg as useTimeout, dU as uuid, d$ as uuid32Decode, d_ as uuid32Encode, dT as uuid32bit, dZ as uuidB32, dS as uuidBytes, dX as uuidDecode, dY as uuidDecodeV4, dV as uuidEncode, dW as uuidEncodeV4, e2 as uuidv4, ag as valueToBoolean, ai as valueToFloat, ah as valueToInteger, aj as valueToString, cC as waitOn } from './uuid-c4ad7468.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare type csvOptions = {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
};
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
